/*
 * Copyright (c) 2010-2011, The MiCode Open Source Community (www.micode.net)
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.micode.notes.gtask.data;

import android.database.Cursor;

import org.json.JSONObject;

public abstract class Node {
    // 同步动作的常量定义，表示不同的同步操作
    public static final int SYNC_ACTION_NONE = 0;              // 无同步动作
    public static final int SYNC_ACTION_ADD_REMOTE = 1;        // 远程添加
    public static final int SYNC_ACTION_ADD_LOCAL = 2;         // 本地添加
    public static final int SYNC_ACTION_DEL_REMOTE = 3;        // 远程删除
    public static final int SYNC_ACTION_DEL_LOCAL = 4;         // 本地删除
    public static final int SYNC_ACTION_UPDATE_REMOTE = 5;     // 远程更新
    public static final int SYNC_ACTION_UPDATE_LOCAL = 6;      // 本地更新
    public static final int SYNC_ACTION_UPDATE_CONFLICT = 7;   // 更新冲突
    public static final int SYNC_ACTION_ERROR = 8;             // 同步错误

    // 节点的GID（全局唯一标识符）
    private String mGid;

    // 节点的名称
    private String mName;

    // 节点的最后修改时间
    private long mLastModified;

    // 节点是否被删除的标记
    private boolean mDeleted;

    // 构造方法，初始化节点的属性
    public Node() {
        mGid = null;           // GID初始化为null
        mName = "";            // 名称初始化为空字符串
        mLastModified = 0;     // 最后修改时间初始化为0
        mDeleted = false;      // 删除标记初始化为false
    }

    // 抽象方法，获取创建动作的JSON对象
    // @param actionId 同步动作的ID
    // @return 包含创建动作的JSON对象
    public abstract JSONObject getCreateAction(int actionId);

    // 抽象方法，获取更新动作的JSON对象
    // @param actionId 同步动作的ID
    // @return 包含更新动作的JSON对象
    public abstract JSONObject getUpdateAction(int actionId);

    // 抽象方法，通过远程JSON对象设置节点内容
    // @param js 包含节点内容的JSON对象
    public abstract void setContentByRemoteJSON(JSONObject js);

    // 抽象方法，通过本地JSON对象设置节点内容
    // @param js 包含节点内容的JSON对象
    public abstract void setContentByLocalJSON(JSONObject js);

    // 抽象方法，从节点内容获取本地JSON对象
    // @return 包含节点内容的本地JSON对象
    public abstract JSONObject getLocalJSONFromContent();

    // 抽象方法，获取同步动作
    // @param c 数据库游标，用于获取节点的同步状态
    // @return 同步动作的ID
    public abstract int getSyncAction(Cursor c);

    // 设置节点的GID
    // @param gid 要设置的GID
    public void setGid(String gid) {
        this.mGid = gid;
    }

    // 设置节点的名称
    // @param name 要设置的名称
    public void setName(String name) {
        this.mName = name;
    }

    // 设置节点的最后修改时间
    // @param lastModified 要设置的最后修改时间
    public void setLastModified(long lastModified) {
        this.mLastModified = lastModified;
    }

    // 设置节点的删除标记
    // @param deleted 要设置的删除标记
    public void setDeleted(boolean deleted) {
        this.mDeleted = deleted;
    }

    // 获取节点的GID
    // @return 节点的GID
    public String getGid() {
        return this.mGid;
    }

    // 获取节点的名称
    // @return 节点的名称
    public String getName() {
        return this.mName;
    }

    // 获取节点的最后修改时间
    // @return 节点的最后修改时间
    public long getLastModified() {
        return this.mLastModified;
    }

    // 获取节点的删除标记
    // @return 节点的删除标记
    public boolean getDeleted() {
        return this.mDeleted;
    }

}
